require_relative "treasure_trove"
require_relative "playable"

module StudioGame
    class Player
    include Playable
    attr_reader  :name
    attr_accessor :health
    
    def initialize(name, health=100)
        @name = name.capitalize
        @health = health
        @found_treasures = Hash.new(0)
    end
    
    def name=(name)
        @name = name.capitalize
    end
    
    def <=>(other)
        other.score <=> score
    end
    
    def to_s
        "I am #{@name.capitalize} with health of #{@health} and a score of #{score}"
    end
    
    def found_treasure(treasure)
        @found_treasures[treasure.name] += treasure.points
        puts "#{@name} found a #{treasure.name} worth #{treasure.points}"
        puts  "#{@name}'s Treasure: #{@found_treasures}"
    end
    
    def each_treasure
        @found_treasures.each do |name,points|
            yield Treasure.new(name,points)
        end
    end
    
    def points
        @found_treasures.values.reduce(0, :+)
    end
    
    def score
        @score = @health + points
    end
end   
   
    
end


if __FILE__ == $0
    player1 = Player.new("sandy")
    puts player1
    player1.woot
end
